VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Database"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'An Enum used to represent three databases
Public Enum DatabaseEnum
  eAS400
  eSQLServer
  eMSAccess
End Enum

Public Function RunSQLStatement(eDBType As DatabaseEnum) As String
  'dim the oDatabase object as the interface IDatabase instead of a specific database object
  Dim oDatabase As IDatabase
  
  'based on which enum was passed in, create an instance of the appropriate database object
  Select Case eDBType
    Case eAS400
      Set oDatabase = New AS400
    Case eSQLServer
      Set oDatabase = New SQLServer
    Case eMSAccess
      Set oDatabase = New MSAccess
  End Select
  
  'call the three public operations that all three types of DB objects share through
  'the IDatabase interface.
  'Polymorphism enables you to issue the same commands to different objects(as long
  'as the different objects share the same interface) and the operations will invoke
  'functionality specific to that object.
  oDatabase.OpenConnection
  RunSQLStatement = oDatabase.RunSQLStatement
  oDatabase.CloseConnection
End Function
